﻿
using System;
using System.Configuration;

namespace EncryptedConfigTestCreator
{
	class Program
	{
		public static void Main(string[] args)
		{
			Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
			ConfigurationSection section = config.Sections["appSettings"];
			ProtectSection(section, "DataProtectionConfigurationProvider");
			
			config.Save();
			
			// Run as admin to get it to get this part to work
//			ConfigurationSectionGroup g1 = config.SectionGroups["TestGroup1"];
//			foreach (ConfigurationSection s in g1.Sections) 
//			{
//				ProtectSection(s, "RsaProtectedConfigurationProvider");
//			}
//			
//			config.Save();
			
			Console.Write("Press any key to continue . . . ");
			Console.ReadKey(true);
		}
		
		private static void ProtectSection(ConfigurationSection section, string providerName)
		{
			if(!section.SectionInformation.IsProtected)
			{
				section.SectionInformation.ProtectSection(providerName);
				section.SectionInformation.ForceSave = true;
			}
		}
	}
}