﻿
using System;
using System.Configuration;

namespace EncryptedConfigTestCreator
{
	/// <summary>
	/// Configuration section &lt;Test1&gt;
	/// </summary>
	/// <remarks>
	/// Assign properties to your child class that has the attribute 
	/// <c>[ConfigurationProperty]</c> to store said properties in the xml.
	/// </remarks>
	public sealed class Test1Settings : ConfigurationSection
	{
		#region ConfigurationProperties
		
		/*
		 *  Uncomment the following section and add a Configuration Collection 
		 *  from the with the file named Test1.cs
		 */
		// /// <summary>
		// /// A custom XML section for an application's configuration file.
		// /// </summary>
		// [ConfigurationProperty("customSection", IsDefaultCollection = true)]
		// public Test1Collection Test1
		// {
		// 	get { return (Test1Collection) base["customSection"]; }
		// }

		/// <summary>
		/// Collection of <c>Test1Element(s)</c> 
		/// A custom XML section for an applications configuration file.
		/// </summary>
		[ConfigurationProperty("exampleAttribute", DefaultValue="exampleValue")]
		public string ExampleAttribute {
			get { return (string) this["exampleAttribute"]; }
			set { this["exampleAttribute"] = value; }
		}

		#endregion

		/// <summary>
		/// Private Constructor used by our factory method.
		/// </summary>
		private Test1Settings () : base () {
			// Allow this section to be stored in user.app. By default this is forbidden.
			this.SectionInformation.AllowExeDefinition =
				ConfigurationAllowExeDefinition.MachineToLocalUser;
		}
	}
}
